
import { _decorator, Component, Node, renderer, gfx, Sprite, ImageAsset, Texture2D, SpriteFrame, MeshRenderer, Material, RenderTexture, Camera, sp, director } from 'cc';
import { BUILD } from 'cc/env';
const { ccclass, property } = _decorator;


@ccclass('reandvideo')
export class reandvideo extends Component {


    @property({ type: Material })
    mesh_Material: Material = null;

    @property({ type: Material })
    sprite_Material: Material = null;//sprite_Texture 更新贴图

    @property({ type: Node })
    mesh_Node: Node = null;



    private _video: HTMLVideoElement = null;;//视频 html元素

    start() {
        this.init();
    }

    update(deltaTime: number) {

        //更新贴图
        this.updateTexture();


    }

    _textssure = new Texture2D();


    updateTexture() {


        //更新贴图
        if (this.isWebCamera) { //是否为摄像头

            this.WebCamera();//手机摄像头

        } 

        this.canvas_video.getContext('2d').drawImage(this._video, 0, 0, 250, 240);
        let base64String = this.canvas_video.toDataURL('image/png');

        var img = new Image();

        img.setAttribute("crossOrigin", 'Anonymous');
        img.src = base64String;

        var self = this;
        img.onload = function () {
            let imgAsset = new ImageAsset();//重置此图像资源使用的原始图像源
            imgAsset.reset(img);


            self._textssure.image = imgAsset;

            self.mesh_Material.setProperty('mainTexture', self._textssure);

            self.mesh_Node.setWorldRotationFromEuler(0, self.mesh_Node.eulerAngles.y + 0.1, 0);


            // let new_texture = self.mesh_Material.getProperty('mainTexture') as Texture2D; //获取贴图  

            self.sprite_Material.setProperty('mainTexture', self._textssure);

        }
    }


    canvas_video = null;//视频 html元素

    init() {
        const video = document.createElement('video');//还是 做的web 页面的video方法 其实我可以拿出其中一部分来 给自己用

        console.log(this._video);

        //window.document.body.appendChild(video);//添加到body中
        video.volume = 0;

        video.id = "video";
        video.autoplay = true;
        video.crossOrigin = "anonymous";
        // video.muted = true;
        video.loop = true;//循环播放

        // this._bindEvent(video)
        video.src = "http://download.cocos.org/CocosTest/test-case/movie.mp4";//公司网络 有限制，用热点就好了~


        this._video = video;//视频 html元素

        let canvas = document.createElement('canvas');
        //window.document.body.appendChild(canvas);//   添加到body中
        canvas.id = "canvas_video";

        canvas.width = 250;
        canvas.height = 240;
        canvas.getContext('2d').drawImage(video, 0, 0, canvas.width, canvas.height);
        let base64String = canvas.toDataURL('image/png');

        this.canvas_video = canvas;//canvas 元素

        console.log(base64String);

        this._video.play();

    }





    videoPlay() { //播放视频
        if (BUILD) {
            this._video.src = null;
        }

        this._video.currentTime = 0;// 时间位置设置为0 开始位置
        this._video.play();
        this._video.volume = 1;

        console.log("videoPlay");
    }

    resumePlay() { //恢复播放
        this._video.play();
    }
    pausePlay() { //暂停播放
        this._video.pause()
    }
    stopPlay() { //停止播放
        this._video.pause()
    }

    isWebCamera: boolean = false;//是否为摄像头

    changeVideo() { //切换视频
        this.isWebCamera = !this.isWebCamera; 
        console.log( this.isWebCamera);
        if (this.isWebCamera==false) { //是否为摄像头

            this._video.src = "http://download.cocos.org/CocosTest/test-case/movie.mp4";

        }
    }


    WebCamera() { //手机摄像头

        return new Promise((resolve, reject) => {
            const mediaConstraints = {
                audio: false, video: {
                    width: this._textssure.width,
                    height: this._textssure.height,
                    brightness: { ideal: 2 }
                }
            };

            navigator.mediaDevices.getUserMedia(mediaConstraints).then(mediaStream => {
                this._video.srcObject = mediaStream;
                this._video.setAttribute('play_video', "true");
                this._video.onloadedmetadata = (e) => {
                    this._video.play();
                    resolve(this._video);
                }
            }).catch(err => {
                reject(err);
            });
        });


    }

}
